[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.144

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.50      afresh1     3: #
1.38      afresh1     4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17:
1.95      afresh1    18: set -o errexit -o pipefail -o nounset -o noclobber -o noglob
1.85      afresh1    19: set +o monitor
1.77      afresh1    20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50      afresh1    21:
                     22: CFILE=SHA256.sig
                     23: DESTDIR=${DESTDIR:-}
                     24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                     25:
                     26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
                     27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
                     28:
                     29: HTTP_FWDIR="$VNAME"
1.52      afresh1    30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
                     31:     /var/run/dmesg.boot | sed '$!d' )
1.50      afresh1    32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22      afresh1    33:
1.50      afresh1    34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                     35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8       afresh1    36:
1.131     afresh1    37: DRYRUN=false
1.138     afresh1    38: VERBOSE=0
1.111     afresh1    39: DELETE=false
1.144   ! afresh1    40: DOWNLOAD=true
1.87      afresh1    41: INSTALL=true
1.69      afresh1    42: LOCALSRC=
                     43:
1.126     afresh1    44: unset FTPPID
1.129     afresh1    45: unset FWPKGTMP
1.126     afresh1    46: REMOVE_LOCALSRC=false
                     47: cleanup() {
1.127     afresh1    48:        set +o errexit # ignore errors from killing ftp
1.128     afresh1    49:        [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
1.129     afresh1    50:        [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
1.126     afresh1    51:        "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
                     52: }
                     53: trap cleanup EXIT
                     54:
1.8       afresh1    55: tmpdir() {
                     56:        local _i=1 _dir
                     57:
1.50      afresh1    58:        # If we're not in the installer,
1.79      afresh1    59:        # we have mktemp and a more hostile environment.
1.50      afresh1    60:        if [ -x /usr/bin/mktemp ]; then
                     61:                _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44      afresh1    62:        else
1.50      afresh1    63:                until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    64:                    ((++_i < 10000)) || return 1
                     65:                done
                     66:        fi
1.50      afresh1    67:
1.8       afresh1    68:        echo "$_dir"
                     69: }
1.6       afresh1    70:
1.50      afresh1    71: fetch() {
1.126     afresh1    72:        local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
1.6       afresh1    73:
1.79      afresh1    74:        # If we're not in the installer,
                     75:        # we have su(1) and doas(1) is unlikely to be configured.
1.85      afresh1    76:        set -o monitor # make sure ftp gets its own process group
                     77:        (
1.138     afresh1    78:        _flags=-vm
                     79:        case "$VERBOSE" in
                     80:                0|1) _flags=-VM ;;
                     81:                  2) _flags=-Vm ;;
                     82:        esac
1.53      afresh1    83:        if [ -x /usr/bin/su ]; then
1.85      afresh1    84:                exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.138     afresh1    85:                    "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $_flags -o- '$_src'" > "$_dst"
1.42      afresh1    86:        else
1.85      afresh1    87:                exec /usr/bin/doas -u "$_user" \
1.138     afresh1    88:                    /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $_flags -o- "$_src" > "$_dst"
1.42      afresh1    89:        fi
1.126     afresh1    90:        ) & FTPPID=$!
1.85      afresh1    91:        set +o monitor
                     92:
                     93:        SECONDS=0
                     94:        _last=0
1.126     afresh1    95:        while kill -0 -"$FTPPID" 2>/dev/null; do
1.85      afresh1    96:                if [[ $SECONDS -gt 12 ]]; then
                     97:                        set -- $( ls -ln "$_dst" 2>/dev/null )
                     98:                        if [[ $_last -ne $5 ]]; then
                     99:                                _last=$5
                    100:                                SECONDS=0
                    101:                                sleep 1
                    102:                        else
1.137     afresh1   103:                                kill -INT -"$FTPPID" 2>/dev/null
1.92      afresh1   104:                                _error=" (timed out)"
1.85      afresh1   105:                        fi
                    106:                else
                    107:                        sleep 1
                    108:                fi
                    109:        done
                    110:
                    111:        set +o errexit
1.126     afresh1   112:        wait "$FTPPID"
1.85      afresh1   113:        _exit=$?
                    114:        set -o errexit
                    115:
1.126     afresh1   116:        unset FTPPID
1.6       afresh1   117:
1.50      afresh1   118:        if [ "$_exit" -ne 0 ]; then
1.69      afresh1   119:                rm -f "$_dst"
1.92      afresh1   120:                echo "Cannot fetch $_src$_error" >&2
1.50      afresh1   121:                return 1
                    122:        fi
1.6       afresh1   123: }
                    124:
1.144   ! afresh1   125: fetch_cfile() {
        !           126:        if "$DOWNLOAD"; then
        !           127:                set +o noclobber # we want to get the latest CFILE
        !           128:                fetch "$CFILE" || return 1
        !           129:                set -o noclobber
        !           130:                ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
        !           131:                    echo "Signature check of SHA256.sig failed" >&2 && return 1
        !           132:        elif [ ! -e "$CFILE" ]; then
        !           133:                echo "${0##*/}: $CFILE: No such file or directory" >&2
        !           134:                return 2
        !           135:        fi
        !           136: }
        !           137:
1.50      afresh1   138: verify() {
1.144   ! afresh1   139:        [ -e "$CFILE" ] || fetch_cfile
1.50      afresh1   140:        # On the installer we don't get sha256 -C, so fake it.
1.69      afresh1   141:        if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                    142:                echo "Checksum test for ${1##*/} failed." >&2
1.50      afresh1   143:                return 1
                    144:        fi
1.6       afresh1   145: }
                    146:
1.124     afresh1   147: firmware_in_dmesg() {
1.90      afresh1   148:        local _d _m _line _dmesgtail _last='' _nl=$( echo )
1.1       afresh1   149:
1.50      afresh1   150:        # When we're not in the installer, the dmesg.boot can
                    151:        # contain multiple boots, so only look in the last one
1.133     afresh1   152:        _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )"
1.50      afresh1   153:
1.89      afresh1   154:        grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                    155:            while read -r _d _m; do
                    156:                [ "$_d" = "$_last" ] && continue
1.90      afresh1   157:                [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                    158:                [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
1.83      afresh1   159:
1.89      afresh1   160:                if [[ $_dmesgtail = *$_m* ]]; then
                    161:                        echo "$_d"
                    162:                        _last="$_d"
                    163:                fi
                    164:            done
1.50      afresh1   165: }
1.14      afresh1   166:
1.50      afresh1   167: firmware_filename() {
1.56      afresh1   168:        local _f
1.144   ! afresh1   169:        [ -e "$CFILE" ] || fetch_cfile
1.56      afresh1   170:        _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
                    171:        ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                    172:        echo "$_f"
1.50      afresh1   173: }
1.7       afresh1   174:
1.57      afresh1   175: firmware_devicename() {
                    176:        local _d="${1##*/}"
                    177:        _d="${_d%-firmware-*}"
                    178:        echo "$_d"
                    179: }
                    180:
1.50      afresh1   181: installed_firmware() {
1.110     afresh1   182:        local _pre="$1" _match="$2" _post="$3" _firmware
1.123     afresh1   183:        set -sA _firmware -- $(
1.109     afresh1   184:            set +o noglob
                    185:            grep -Fxl '@option firmware' \
1.110     afresh1   186:                "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
1.109     afresh1   187:                2>/dev/null || true
                    188:            set -o noglob
                    189:        )
                    190:
                    191:        [ "${_firmware[*]:-}" ] || return 0
                    192:        for fw in "${_firmware[@]}"; do
                    193:                fw="${fw%/+CONTENTS}"
1.50      afresh1   194:                echo "${fw##*/}"
                    195:        done
                    196: }
1.1       afresh1   197:
1.124     afresh1   198: detect_firmware() {
                    199:        local _devices _last='' _d
                    200:
                    201:        set -sA _devices -- $(
                    202:            firmware_in_dmesg
                    203:            for _d in $( installed_firmware '*' '-firmware-' '*' ); do
1.135     afresh1   204:                firmware_devicename "$_d"
1.124     afresh1   205:            done
                    206:        )
                    207:
                    208:        [ "${_devices[*]:-}" ] || return 0
                    209:        for _d in "${_devices[@]}"; do
1.135     afresh1   210:                [ "$_last" = "$_d" ] && continue
                    211:                echo "$_d"
1.124     afresh1   212:                _last="$_d"
                    213:        done
                    214: }
                    215:
1.50      afresh1   216: add_firmware () {
1.139     afresh1   217:        local _f="${1##*/}" _m="${2:-Install}" _pkgname
1.129     afresh1   218:        FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
1.138     afresh1   219:        local _flags=-vm
                    220:        case "$VERBOSE" in
                    221:                0|1) _flags=-VM ;;
                    222:                2|3) _flags=-Vm ;;
                    223:        esac
                    224:
1.139     afresh1   225:        ftp -N "${0##/}" -D "$_m" "$_flags" -o- "file:${1}" |
1.129     afresh1   226:                tar -s ",^\+,${FWPKGTMP}/+," \
1.69      afresh1   227:                    -s ",^firmware,${DESTDIR}/etc/firmware," \
                    228:                    -C / -zxphf - "+*" "firmware/*"
1.1       afresh1   229:
1.129     afresh1   230:        _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
1.106     afresh1   231:        if [ ! "$_pkgname" ]; then
                    232:                echo "Failed to extract name from $1, partial install" 2>&1
1.129     afresh1   233:                rm -rf "$FWPKGTMP"
                    234:                unset FWPKGTMP
1.106     afresh1   235:                return 1
                    236:        fi
                    237:
1.50      afresh1   238:        # TODO: Should we mark these so real fw_update can -Drepair?
1.129     afresh1   239:        ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
1.50      afresh1   240: /^@comment pkgpath/ -1a
                    241: @option manual-installation
                    242: @option firmware
                    243: @comment install-script
                    244: .
                    245: w
                    246: EOL
1.106     afresh1   247:
1.129     afresh1   248:        chmod 755 "$FWPKGTMP"
                    249:        mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
                    250:        unset FWPKGTMP
1.50      afresh1   251: }
1.22      afresh1   252:
1.50      afresh1   253: delete_firmware() {
1.51      afresh1   254:        local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22      afresh1   255:
1.50      afresh1   256:        # TODO: Check hash for files before deleting
1.140     afresh1   257:        [ "$VERBOSE" -gt 2 ] && echo -n "Uninstall $_pkg ..."
1.51      afresh1   258:        _cwd="${_pkgdir}/$_pkg"
1.50      afresh1   259:
1.107     afresh1   260:        if [ ! -e "$_cwd/+CONTENTS" ] ||
                    261:            ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                    262:                echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                    263:                return 2
                    264:        fi
                    265:
1.51      afresh1   266:        set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50      afresh1   267:
                    268:        while read -r c g; do
                    269:                case $c in
1.51      afresh1   270:                @cwd) _cwd="${DESTDIR}$g"
1.50      afresh1   271:                  ;;
                    272:                @*) continue
                    273:                  ;;
1.52      afresh1   274:                *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50      afresh1   275:                  ;;
                    276:                esac
                    277:        done < "${_pkgdir}/${_pkg}/+CONTENTS"
                    278:
                    279:        # We specifically rm -f here because not removing files/dirs
                    280:        # is probably not worth failing over.
                    281:        for _r in "${_remove[@]}" ; do
                    282:                if [ -d "$_r" ]; then
                    283:                        # Try hard not to actually remove recursively
                    284:                        # without rmdir on the install media.
1.95      afresh1   285:                        set +o noglob
1.50      afresh1   286:                        [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
1.95      afresh1   287:                        set -o noglob
1.50      afresh1   288:                else
                    289:                        rm -f "$_r"
1.22      afresh1   290:                fi
                    291:        done
1.138     afresh1   292:
1.140     afresh1   293:        [ "$VERBOSE" -gt 2 ] && echo " done."
1.139     afresh1   294:
                    295:        return 0
1.50      afresh1   296: }
1.1       afresh1   297:
1.59      afresh1   298: usage() {
1.122     afresh1   299:        echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
1.59      afresh1   300:        exit 2
                    301: }
                    302:
1.113     afresh1   303: ALL=false
1.142     afresh1   304: OPT_F=
                    305: while getopts :adFnp:v name
1.59      afresh1   306: do
                    307:        case "$name" in
1.113     afresh1   308:        a) ALL=true ;;
1.111     afresh1   309:        d) DELETE=true ;;
1.142     afresh1   310:        F) OPT_F=true ;;
1.131     afresh1   311:        n) DRYRUN=true ;;
1.121     afresh1   312:        p) LOCALSRC="$OPTARG" ;;
1.138     afresh1   313:        v) VERBOSE=$(( VERBOSE + 1 )) ;;
1.121     afresh1   314:        :)
                    315:           echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
                    316:           usage 2
                    317:           ;;
                    318:        ?)
                    319:           echo "${0##*/}: unknown option -- -$OPTARG" >&2
                    320:           usage 2
                    321:           ;;
1.59      afresh1   322:        esac
                    323: done
                    324: shift $((OPTIND - 1))
                    325:
1.121     afresh1   326: if [ "$LOCALSRC" ]; then
                    327:        if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
                    328:                FWURL="${LOCALSRC}"
                    329:                LOCALSRC=
                    330:        else
                    331:                LOCALSRC="${LOCALSRC:#file:}"
                    332:                ! [ -d "$LOCALSRC" ] &&
                    333:                    echo "The path must be a URL or an existing directory" >&2 &&
                    334:                    exit 2
                    335:        fi
                    336: fi
                    337:
1.122     afresh1   338: # "Download only" means local dir and don't install
1.142     afresh1   339: if [ "$OPT_F" ]; then
1.87      afresh1   340:        INSTALL=false
1.121     afresh1   341:        LOCALSRC="${LOCALSRC:-.}"
1.144   ! afresh1   342:
        !           343:        # Always check for latest CFILE and so latest firmware
        !           344:        if [ -e "$LOCALSRC/$CFILE" ]; then
        !           345:                mv "$LOCALSRC/$CFILE" "$LOCALSRC/$CFILE-OLD"
        !           346:                if fetch_cfile; then
        !           347:                        rm -f "$LOCALSRC/$CFILE-OLD"
        !           348:                else
        !           349:                        mv "$LOCALSRC/$CFILE-OLD" "$LOCALSRC/$CFILE"
        !           350:                        echo "Using existing $CFILE" >&2
        !           351:                fi
        !           352:        fi
1.130     afresh1   353: elif [ "$LOCALSRC" ]; then
                    354:        DOWNLOAD=false
1.87      afresh1   355: fi
1.64      afresh1   356:
1.118     afresh1   357: if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
                    358:        echo "need root privileges" >&2
                    359:        exit 1
1.94      afresh1   360: fi
                    361:
1.123     afresh1   362: set -sA devices -- "$@"
1.111     afresh1   363:
                    364: if "$DELETE"; then
1.142     afresh1   365:        [ "$OPT_F" ] && usage 22
1.111     afresh1   366:
1.139     afresh1   367:        # Show the "Uninstalling" message when just deleting not upgrading
1.141     afresh1   368:        [ "$VERBOSE" -gt 0 ] && VERBOSE=3
1.139     afresh1   369:
1.113     afresh1   370:        set -A installed
                    371:        if [ "${devices[*]:-}" ]; then
                    372:                "$ALL" && usage 22
                    373:
                    374:                set -A installed -- $(
                    375:                    for d in "${devices[@]}"; do
                    376:                        f="${d##*/}"  # only care about the name
                    377:                        f="${f%.tgz}" # allow specifying the package name
                    378:                        [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
                    379:
                    380:                        set -A i -- $( installed_firmware '' "$f-" '*' )
                    381:
                    382:                        if [ "${i[*]:-}" ]; then
                    383:                                echo "${i[@]}"
                    384:                        else
                    385:                                echo "No firmware found for '$d'" >&2
                    386:                        fi
                    387:                    done
                    388:                )
                    389:        elif "$ALL"; then
                    390:                set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
                    391:        fi
1.111     afresh1   392:
                    393:        deleted=''
1.113     afresh1   394:        if [ "${installed:-}" ]; then
1.111     afresh1   395:                for fw in "${installed[@]}"; do
1.131     afresh1   396:                        if "$DRYRUN"; then
1.138     afresh1   397:                                [ "$VERBOSE" -gt 0 ] && echo "Delete $fw"
1.131     afresh1   398:                        else
                    399:                                delete_firmware "$fw" || continue
                    400:                        fi
1.112     afresh1   401:                        deleted="$deleted,$( firmware_devicename "$fw" )"
1.111     afresh1   402:                done
1.113     afresh1   403:        fi
1.111     afresh1   404:
1.139     afresh1   405:        deleted="${deleted#,}"
1.111     afresh1   406:        echo "${0:##*/}: deleted ${deleted:-none}";
                    407:
                    408:        exit
                    409: fi
1.125     afresh1   410:
                    411: if [ ! "$LOCALSRC" ]; then
                    412:     LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
1.126     afresh1   413:     REMOVE_LOCALSRC=true
1.125     afresh1   414: fi
                    415:
1.144   ! afresh1   416: CFILE="$LOCALSRC/$CFILE"
        !           417:
1.113     afresh1   418: if [ "${devices[*]:-}" ]; then
                    419:        "$ALL" && usage 22
                    420: else
1.139     afresh1   421:        [ "$VERBOSE" -gt 1 ] && echo -n "Detect firmware ..."
1.124     afresh1   422:        set -sA devices -- $( detect_firmware )
1.139     afresh1   423:        [ "$VERBOSE" -gt 1 ] &&
1.101     afresh1   424:            { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
1.50      afresh1   425: fi
1.91      afresh1   426:
                    427: [ "${devices[*]:-}" ] || exit
1.50      afresh1   428:
1.103     afresh1   429: added=''
                    430: updated=''
1.115     afresh1   431: kept=''
1.70      afresh1   432: for f in "${devices[@]}"; do
                    433:        d="$( firmware_devicename "$f" )"
                    434:
1.58      afresh1   435:        if [ "$f" = "$d" ]; then
                    436:                f=$( firmware_filename "$d" || true )
                    437:                [ "$f" ] || continue
1.69      afresh1   438:                f="$LOCALSRC/$f"
1.76      afresh1   439:        elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70      afresh1   440:                echo "Cannot download local file $f" >&2
                    441:                exit 2
1.58      afresh1   442:        fi
                    443:
1.110     afresh1   444:        set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
1.50      afresh1   445:
1.68      afresh1   446:        if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65      afresh1   447:                for i in "${installed[@]}"; do
1.58      afresh1   448:                        if [ "${f##*/}" = "$i.tgz" ]; then
1.139     afresh1   449:                                [ "$VERBOSE" -gt 2 ] && echo "Keep $i"
1.115     afresh1   450:                                kept="$kept,$d"
1.11      afresh1   451:                                continue 2
1.1       afresh1   452:                        fi
                    453:                done
1.50      afresh1   454:        fi
1.1       afresh1   455:
1.72      afresh1   456:        if [ -e "$f" ]; then
                    457:                if "$DOWNLOAD"; then
1.140     afresh1   458:                        [ "$VERBOSE" -gt 1 ] && ! "$INSTALL" &&
1.134     afresh1   459:                            echo "Keep/Verify ${f##*/}"
1.131     afresh1   460:                        "$DRYRUN"  || verify "$f" || continue
                    461:                        "$INSTALL" || kept="$kept,$d"
1.72      afresh1   462:                # else assume it was verified when downloaded
                    463:                fi
1.75      afresh1   464:        elif "$DOWNLOAD"; then
1.131     afresh1   465:                if "$DRYRUN"; then
1.138     afresh1   466:                        [ "$VERBOSE" -gt 0 ] && echo "Get/Verify ${f##*/}"
1.131     afresh1   467:                else
1.138     afresh1   468:                        [ "$VERBOSE" -eq 1 ] && echo -n "Get/Verify ${f##*/} ..."
                    469:                        fetch  "$f" &&
                    470:                        verify "$f" ||
                    471:                            { [ "$VERBOSE" -eq 1 ] && echo " failed."; continue; }
1.139     afresh1   472:                        [ "$VERBOSE" -eq 1 ] && ! "$INSTALL" && echo " done."
1.131     afresh1   473:                fi
1.138     afresh1   474:                "$INSTALL" || added="$added,$d"
1.75      afresh1   475:        elif "$INSTALL"; then
1.72      afresh1   476:                echo "Cannot install ${f##*/}, not found" >&2
                    477:                continue
1.58      afresh1   478:        fi
1.60      afresh1   479:
1.68      afresh1   480:        "$INSTALL" || continue
1.11      afresh1   481:
1.139     afresh1   482:        update=''
1.65      afresh1   483:        if [ "${installed[*]:-}" ]; then
1.50      afresh1   484:                for i in "${installed[@]}"; do
1.131     afresh1   485:                        "$DRYRUN" || delete_firmware "$i"
1.139     afresh1   486:                        update="Update"
1.50      afresh1   487:                done
                    488:        fi
1.11      afresh1   489:
1.139     afresh1   490:        "$DRYRUN" || add_firmware "$f" "$update"
1.103     afresh1   491:
1.131     afresh1   492:        f="${f##*/}"
                    493:        f="${f%.tgz}"
1.139     afresh1   494:        if [ "$update" ]; then
1.140     afresh1   495:                if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
                    496:                        echo " updated."
1.139     afresh1   497:                elif [ "$VERBOSE" -eq 1 ]; then
1.140     afresh1   498:                        echo "Update $f"
                    499:                elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                    500:                        echo "Update $f"
1.139     afresh1   501:                fi
1.114     afresh1   502:                updated="$updated,$d"
1.103     afresh1   503:        else
1.140     afresh1   504:                if [ "$VERBOSE" -eq 1 ] && "$DOWNLOAD" && ! "$DRYRUN"; then
                    505:                        echo " installed."
1.139     afresh1   506:                elif [ "$VERBOSE" -eq 1 ]; then
1.140     afresh1   507:                        echo "Install $f"
                    508:                elif [ "$VERBOSE" -gt 0 ] && "$DRYRUN"; then
                    509:                        echo "Install $f"
1.139     afresh1   510:                fi
1.114     afresh1   511:                added="$added,$d"
1.103     afresh1   512:        fi
1.50      afresh1   513: done
1.1       afresh1   514:
1.114     afresh1   515: added="${added:#,}"
                    516: updated="${updated:#,}"
1.115     afresh1   517: kept="${kept:#,}"
1.117     afresh1   518: if "$INSTALL"; then
                    519:        echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
                    520: else
                    521:        echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
                    522: fi

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>